# Convolution Exploration - Documents > References


## Description
Various references used in project.


## C++ References

### Book Reference
"A Tour of C++", by Bjarne Stroustrup

### File and Directory Handling

#### Path Management
* Check if file path exists - <https://stackoverflow.com/a/27588225>
* Check if path is file or directory - <https://stackoverflow.com/a/43281413>
* Get file name from path - <https://stackoverflow.com/a/24386991>
* Path value to string - <https://stackoverflow.com/a/45401869>
* Get current directory - <https://stackoverflow.com/a/52522000>

#### Folder Management
* Check if dir exists - <https://stackoverflow.com/a/18101042>
* Create directory - <https://www.geeksforgeeks.org/create-directoryfolder-cc-program/>
* Get all files in folder - <https://stackoverflow.com/a/612176>


### Other
#### C++ Strings
* What is a C++ string - <https://stackoverflow.com/a/3535904>
* String splitting - <https://stackoverflow.com/a/14266139>
* Getting File/LineNum:
** <https://stackoverflow.com/a/42135375>
** <https://stackoverflow.com/a/8884408>
* Append variables to strings - <https://stackoverflow.com/a/10219339> <https://stackoverflow.com/a/18997915>

#### C++ Classes
* General Class Syntax - <https://www.w3schools.com/cpp/cpp_classes.asp>
* Structs Vs Classes in C++ - <https://stackoverflow.com/a/36917400>
* Deconstructors - <https://www.geeksforgeeks.org/destructors-c/>
* Splitting into header files - <https://stackoverflow.com/a/9579974>

#### Type Casting
<https://en.cppreference.com/w/cpp/language/static_cast>

#### Reading In & Manipulating Image Files
* <https://stackoverflow.com/a/59553786>
* <https://stackoverflow.com/a/5420568>

#### Memory Management
<https://www.geeksforgeeks.org/delete-in-c/>

#### Tracking Time Elapsed
* Tracking Time - <https://stackoverflow.com/a/1735321>
* Mod on Doubles - <https://stackoverflow.com/a/9138794>
* Setting Double Precision - <https://stackoverflow.com/a/16280182>
* Saving Precision without Immediate Output to Console - <https://stackoverflow.com/a/48945767>


## CUDA References

### Book Reference
"Cuda by Example", by Jason Sanders & Edward Kandrot

### First CUDA Program
<https://developer.nvidia.com/blog/easy-introduction-cuda-c-and-c/>

### Intro CUDA Tutorial
<https://cuda-tutorial.readthedocs.io/en/latest/tutorials/tutorial01/>


## General Errors

#### Files Compiling without "Standard" C++ Library Access
<https://stackoverflow.com/a/10271117>





# c++ manipulate pixels in image

https://www.scratchapixel.com/lessons/digital-imaging/simple-image-manipulations
